Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time.field
Class DecoratedDurationField

    java.lang.Object
      org.joda.time.DurationField
          org.joda.time.field.BaseDurationField
              org.joda.time.field.DecoratedDurationField

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable

Direct Known Subclasses:
  ScaledDurationField

    public class DecoratedDurationField

extends BaseDurationField

`DecoratedDurationField` extends `BaseDurationField`, implementing only the minimum required set of methods. These implemented methods delegate to a wrapped field.

This design allows new DurationField types to be defined that piggyback on top of another, inheriting all the safe method implementations from BaseDurationField. Should any method require pure delegation to the wrapped field, simply override and use the provided getWrappedField method.

DecoratedDurationField is thread-safe and immutable, and its subclasses must be as well.

Since:
  1.0
Author:
  Brian S O'Neill
See Also:
  `DelegatedDurationField`, Serialized Form

Constructor Summary
`DecoratedDurationField(DurationField field, DurationFieldType type)` Constructor.

Method Summary
`long` | `add(long instant, int value)` Adds a duration value (which may be negative) to the instant.
`long` | `add(long instant, long value)` Adds a duration value (which may be negative) to the instant.
`long` | `getDifferenceAsLong(long minuendInstant, long subtrahendInstant)` Computes the difference between two instants, as measured in the units of this field.
`long` | `getMillis(int value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`long` | `getMillis(long value, long instant)` Get the millisecond duration of this field from its value relative to an instant.
`long` | `getUnitMillis()` Returns the amount of milliseconds per unit value of this field.
`long` | `getValueAsLong(long duration, long instant)` Get the value of this field from the milliseconds relative to an instant.
`DurationField` | `getWrappedField()` Gets the wrapped duration field.
`boolean` | `isPrecise()` Is this field precise.

Methods inherited from class org.joda.time.field.BaseDurationField
`compareTo, getDifference, getMillis, getMillis, getName, getType, getValue, getValue, getValueAsLong, isSupported, toString`

Methods inherited from class org.joda.time.DurationField
`subtract, subtract`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### DecoratedDurationField

    public DecoratedDurationField(DurationField field,
                                  DurationFieldType type)

  Constructor.

  Parameters:
    `field` - the base field
    `type` - the type to actually use

Method Detail

### getWrappedField

    public final DurationField getWrappedField()

  Gets the wrapped duration field.

  Returns:
    the wrapped DurationField

### isPrecise

    public boolean isPrecise()

  Description copied from class: `DurationField`
  Is this field precise. A precise field can calculate its value from milliseconds without needing a reference date. Put another way, a precise field's unit size is not variable.

  Specified by:
    `isPrecise` in class `DurationField`
  Returns:
    true if precise
  See Also:
    `DurationField.getUnitMillis()`

### getValueAsLong

    public long getValueAsLong(long duration,
                               long instant)

  Description copied from class: `DurationField`
  Get the value of this field from the milliseconds relative to an instant. For precise fields this method produces the same result as for the single argument get method.

  If the millisecond duration is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Specified by:
    `getValueAsLong` in class `DurationField`
  Parameters:
    `duration` - the milliseconds to query, which may be negative
    `instant` - the start instant to calculate relative to
  Returns:
    the value of the field, in the units of the field, which may be negative

### getMillis

    public long getMillis(int value,
                          long instant)

  Description copied from class: `DurationField`
  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Specified by:
    `getMillis` in class `DurationField`
  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### getMillis

    public long getMillis(long value,
                          long instant)

  Description copied from class: `DurationField`
  Get the millisecond duration of this field from its value relative to an instant. For precise fields this method produces the same result as for the single argument getMillis method.

  If the value is positive, then the instant is treated as a "start instant". If negative, the instant is treated as an "end instant".

  Specified by:
    `getMillis` in class `DurationField`
  Parameters:
    `value` - the value of the field, which may be negative
    `instant` - the instant to calculate relative to
  Returns:
    the millisecond duration that the field represents, which may be negative

### add

    public long add(long instant,
                    int value)

  Description copied from class: `DurationField`
  Adds a duration value (which may be negative) to the instant.

  Specified by:
    `add` in class `DurationField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### add

    public long add(long instant,
                    long value)

  Description copied from class: `DurationField`
  Adds a duration value (which may be negative) to the instant.

  Specified by:
    `add` in class `DurationField`
  Parameters:
    `instant` - the milliseconds from 1970-01-01T00:00:00Z to add to
    `value` - the value to add, in the units of the field
  Returns:
    the updated milliseconds

### getDifferenceAsLong

    public long getDifferenceAsLong(long minuendInstant,
                                    long subtrahendInstant)

  Description copied from class: `DurationField`
  Computes the difference between two instants, as measured in the units of this field. Any fractional units are dropped from the result. Calling getDifference reverses the effect of calling add. In the following code:

       long instant = ...
       long v = ...
       long age = getDifferenceAsLong(add(instant, v), instant);

  The value 'age' is the same as the value 'v'.

  Specified by:
    `getDifferenceAsLong` in class `DurationField`
  Parameters:
    `minuendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract from
    `subtrahendInstant` - the milliseconds from 1970-01-01T00:00:00Z to subtract off the minuend
  Returns:
    the difference in the units of this field

### getUnitMillis

    public long getUnitMillis()

  Description copied from class: `DurationField`
  Returns the amount of milliseconds per unit value of this field. For example, if this field represents "seconds", then this returns the milliseconds in one second.

  For imprecise fields, the unit size is variable, and so this method returns a suitable average value.

  Specified by:
    `getUnitMillis` in class `DurationField`
  Returns:
    the unit size of this field, in milliseconds
  See Also:
    `DurationField.isPrecise()`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD